/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#pragma once


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif



#include <PalmOS.h>
#include "ROM Transfer.rsrc.h"

#include <SerialMgr.h>
#include <Crc.h>


// Globals.

extern UInt16 gPortReference;


#define kPort_Pilot				0

#define kBaud_1200				1200
#define kBaud_2400				2400
#define kBaud_4800				4800
#define kBaud_9600				9600
#define kBaud_14400				14400
#define kBaud_19200				19200
#define kBaud_28800				28800
#define kBaud_38400				38400
#define kBaud_57600				57600
#define kBaud_57600				57600
#define kBaud_115200			115200

// Error Constants.

#define kError_CommOpen			10000
#define kError_CommNotOpen		10001
#define kError_InvalidPort		10002
#define kError_CantOpenPort		10003
#define kError_PortOpen			10004

// Prototypes.

#ifdef __cplusplus
extern "C" {
#endif


Int16		Comm_Initialize	(Int16 iPort, UInt32 iBaud);
void		Comm_Dispose	(void);
void		Comm_ClearError	(void);


#ifdef __cplusplus
}
#endif


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif
