/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef _ATRAPS_H_
#define _ATRAPS_H_

#include "Miscellaneous.h"		// StMemoryMapper

class SessionFile;

class ATrap
{
	public:
								ATrap		(void);
								~ATrap		(void);

		long					Call		(uint16 trapWord);

		void					PushByte	(uint8 iByte);
		void					PushWord	(uint16 iWord);
		void					PushLong	(uint32 iLong);

		void					SetNewDReg	(int regNum, uint32 value);
		void					SetNewAReg	(int regNum, uint32 value);

		uint32					GetD0		(void);
		uint32					GetA0		(void);

		static Bool				DoingCall	(void) { return fgCallCount > 0; }

		static void				Initialize	(void);
		static void				Reset		(void);
		static void				Save		(SessionFile&);
		static void				Load		(SessionFile&);
		static void				Dispose		(void);

	protected:

		long					DoCall		(uint16 trapWord);

	private:
		regstruct				fNewRegisters;

		static long				fgCallCount;

//		static const int		kStackSize = 4096;	// VC++ is a bit medieval here...
		enum { kStackSize = 4096 };
		char					fStack[kStackSize];

		StMemoryMapper			fEmulatedStackMapper;
};

#endif /* _ATRAPS_H_ */

