/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef _BANK_MAPPED_H_
#define _BANK_MAPPED_H_


class SessionFile;

class MappedBank
{
	public:
		static void				Initialize			(void);
		static void				Reset				(void);
		static void				Save				(SessionFile&);
		static void				Load				(SessionFile&);
		static void				Dispose				(void);

		static void				SetBankHandlers		(void);

		static uint32			GetLong				(emuptr iAddress);
		static uint32			GetWord				(emuptr iAddress);
		static uint32			GetByte				(emuptr iAddress);
		static void				SetLong				(emuptr iAddress, uint32 iLongValue);
		static void				SetWord				(emuptr iAddress, uint32 iWordValue);
		static void				SetByte				(emuptr iAddress, uint32 iByteValue);
		static int				ValidAddress		(emuptr iAddress, uint32 iSize);
		static uint8*			GetRealAddress		(emuptr iAddress);
		static uint8*			GetMetaAddress		(emuptr iAddress);
		static emuptr			GetEmulatedAddress	(const void* iAddress);
		static void				AddOpcodeCycles		(void);

		static void				MapPhysicalMemory	(const void*, uint32);
		static void				UnmapPhysicalMemory	(const void*);

		static void				GetMappingInfo		(emuptr addr, void** start, uint32* len);


	private:
		static void				InvalidAccess		(emuptr iAddress, long size, Bool forRead);
};


#endif /* _BANK_MAPPED_H_ */
