/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef _BANK_SED1375_H_
#define _BANK_SED1375_H_

#include "EmulatorTypes.h"			// RGBType

class SessionFile;

class SED1375Bank
{
	public:
		static void				Initialize			(void);
		static void				Reset				(void);
		static void				Save				(SessionFile&);
		static void				Load				(SessionFile&);
		static void				Dispose				(void);

		static void				SetBankHandlers		(void);
		static void				SetSubHandlers		(void);

		static uint32			GetLong				(emuptr iAddress);
		static uint32			GetWord				(emuptr iAddress);
		static uint32			GetByte				(emuptr iAddress);
		static void				SetLong				(emuptr iAddress, uint32 iLongValue);
		static void				SetWord				(emuptr iAddress, uint32 iWordValue);
		static void				SetByte				(emuptr iAddress, uint32 iByteValue);
		static int				ValidAddress		(emuptr iAddress, uint32 iSize);
		static uint8*			GetRealAddress		(emuptr iAddress);
		static uint8*			GetMetaAddress		(emuptr iAddress);

		static int32			GetLCDDepth			(void);
		static int32			GetLCDRowBytes		(void);
		static int32			GetLCDWidth			(void);
		static int32			GetLCDHeight		(void);
		static emuptr			GetLCDStartAddr		(void);
		static int32			GetLCDPalette		(RGBType* scrPalette);
		static int32			GetLCDOffset		(void);
		static Bool				GetLCDOn			(void);
		static Bool				GetBacklightOn		(void);

	private:
		static void				InvalidAccess		(emuptr iAddress, long size, Bool forRead);
		static void				PreventedAccess		(emuptr iAddress, long size, Bool forRead);

		friend class SED1375Reg;	// Calls SED1375Bank::InvalidAccess
};

#endif /* _BANK_SED1375_H_ */
  
