/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmCommon_h
#define EmCommon_h

// Common header file included by all Palm OS Emulator files.

// ==================================================================================
// Configuration
// ==================================================================================

// Pull in switches that define our configuration.  We require that the following
// symbols be defined externally, but all the rest are defined in Switches.h.
//
//		_DEBUG or NDEBUG
//		HAS_PROFILING (0 or 1)
//		INCLUDE_SECRET_STUFF (0 or 1)

#include "Switches.h"


// ==================================================================================
// A couple of very handy macros.
// ==================================================================================

#define countof(a)	(sizeof(a) / sizeof (a[0]))

#define UNUSED_PARAM(x)	((void) x);


// ==================================================================================
// Platform-specific definitions
// ==================================================================================

#if PLATFORM_MAC
	#include "EmCommonMac.h"
#endif

#if PLATFORM_UNIX
	#include "EmCommonUnix.h"
#endif

#if PLATFORM_WINDOWS
	#include "EmCommonWin.h"
#endif

#endif	/* EmCommon_h */
