/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmPalmFunction_h
#define EmPalmFunction_h

#include "EmulatorTypes.h"		// SystemCallContext

void	EmPalmFunctionInit					(void);

Bool	Incj_kptkdelete						(emuptr = m68k_getpc ());
Bool	InBackspaceChar						(emuptr = m68k_getpc ());
Bool	InCrc16CalcBlock					(emuptr = m68k_getpc ());
Bool	InDmWrite							(emuptr = m68k_getpc ());
Bool	InEggOfInfiniteWisdom				(emuptr = m68k_getpc ());
Bool	InFindShowResults					(emuptr = m68k_getpc ());
Bool	InFindSaveFindStr					(emuptr = m68k_getpc ());
Bool	InFldDelete							(emuptr = m68k_getpc ());
Bool	InFntDefineFont						(emuptr = m68k_getpc ());
Bool	InGrfProcessStroke					(emuptr = m68k_getpc ());
Bool	InMemMove							(emuptr = m68k_getpc ());
Bool	InMenuHandleEvent					(emuptr = m68k_getpc ());
Bool	InNetPrvSettingSet					(emuptr = m68k_getpc ());
Bool	InNetPrvTaskMain					(emuptr = m68k_getpc ());
Bool	InPrvCompressedInnerBitBlt			(emuptr = m68k_getpc ());
Bool	InPrvConvertDepth1To2BW				(emuptr = m68k_getpc ());
Bool	InPrvFindMemoryLeaks				(emuptr = m68k_getpc ());
Bool	InPrvMisAlignedForwardInnerBitBlt	(emuptr = m68k_getpc ());
Bool	InPrvMisAlignedBackwardInnerBitBlt	(emuptr = m68k_getpc ());
Bool	InPrvSystemTimerProc				(emuptr = m68k_getpc ());
Bool	InSecPrvRandomSeed					(emuptr = m68k_getpc ());
Bool	InSysAppExit						(emuptr = m68k_getpc ());
Bool	InTsmGlueGetFepMode					(emuptr = m68k_getpc ());
Bool	InTsmGlueSetFepMode					(emuptr = m68k_getpc ());

Bool	InHsPrvInit							(emuptr = m68k_getpc ());

emuptr	GetFunctionAddress		(uint16 trapWord, uint32 extra = sysInvalidRefNum, Bool digDeep = false);
emuptr	GetLibFunctionAddress	(uint16 trapWord, UInt16 refNum, Bool digDeep);
emuptr	GetSysFunctionAddress	(uint16 trapWord, uint32 extra, Bool digDeep);
emuptr	GetStdDispatchAddress	(emuptr entryPt, uint32 regD2);
emuptr	GetFlpEmDispatchAddress	(emuptr entryPt, uint32 regD2);


class EmUnimplementedFunctionException
{
	public:
		EmUnimplementedFunctionException (long n = 0) :
			fLibIndex (n)
		{
		}

		long	fLibIndex;
};

class EmInvalidRefNumException
{
	public:
		EmInvalidRefNumException (long n = 0, long m = sysInvalidRefNum) :
			fLibIndex (n),
			fMaxRefNum (m)
		{
		}

		long	fLibIndex;
		long	fMaxRefNum;
};

char*	GetTrapName				(const SystemCallContext&, Bool digDeep = false);
char*	GetTrapName				(uint16 trapWord, uint32 extra = sysInvalidRefNum, Bool digDeep = false);
void	FindTrapName			(uint16 trapWord, char* nameP, uint32 extra = sysInvalidRefNum, Bool digDeep = false);

// Llamagraphics, Inc:  Added nameCapacity argument so that callers
// can retrieve more than 31 character function names.  The default
// capacity is 32, so callers that don't provide the extra argument
// will get the same result as before.

void	FindFunctionName		(emuptr addr,
								 char* nameP,
								 emuptr* startAddrP = NULL,
								 emuptr* endAddrP = NULL,
								 long nameCapacity = 32);
emuptr	FindFunctionStart		(emuptr addr);
emuptr	FindFunctionEnd			(emuptr addr);
Bool	EndOfFunctionSequence	(emuptr addr);

// Llamagraphics, Inc:  Added nameCapacity argument so that callers
// can retrieve more than 31 character function names.  The default
// capacity is 32, so callers that don't provide the extra argument
// will get the same result as before.

void	CopyMacsbugName			(emuptr eof, char* name, long nameCapacity = 32);
uint8	MacsbugNameLength		(emuptr& addr, Bool* isFixed);
Bool	ValidMacsbugChar		(uint8 ch);

#endif	/* EmPalmFunction_h */
