/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#include "EmCommon.h"
#include "EmPalmStructs.h"

#include "EmulatorTypes.h"

int BadGetter (void)
{
	assert (false);
	return 0;
}

void BadSetter (void)
{
	assert (false);
}


// CHECK_FIELD_OFFSET generates code that at compile-time can verify the offset
// a field in a struct.

#define CHECK_FIELD_OFFSET(offset, struct_type, field_type, field_name, field_name2)		\
	{																						\
		char	dummy_##field_name2[offsetof(struct_type, field_name) == offset ? 1 : 0];	\
		(void) dummy_##field_name2;															\
	}

#define CHECK_STRUCT_OFFSETS(struct_type, struct_size, FOR_EACH_FIELD)					\
	{																					\
		FOR_EACH_FIELD(CHECK_FIELD_OFFSET)												\
		{																				\
			char	dummy_##struct_type[struct_size == sizeof(struct_type) ? 1 : 0];	\
			(void) dummy_##struct_type;													\
		}																				\
	}

#if 0
static void Dummy (unsigned long)
{
}

static void Set1 (EmProxySysPktRPC2Type& packet)
{
	packet.command = 0x11223344;
}

static void Set1 (SysPktRPC2Type& packet)
{
	packet.command = 0x11223344;
}

static void Set2 (EmProxySysPktRPC2Type& packet)
{
	packet.trapWord = 0x22334455;
}

static void Set2 (SysPktRPC2Type& packet)
{
	packet.trapWord = 0x22334455;
}

static void Set4 (EmProxySysPktRPC2Type& packet)
{
	packet.resultD0 = 0x33445566;
}

static void Set4 (SysPktRPC2Type& packet)
{
	packet.resultD0 = 0x33445566;
}

static void Get1 (EmProxySysPktRPC2Type& packet)
{
	Dummy (packet.command);
}

static void Get1 (SysPktRPC2Type& packet)
{
	Dummy (packet.command);
}

static void Get2 (EmProxySysPktRPC2Type& packet)
{
	Dummy (packet.trapWord);
}

static void Get2 (SysPktRPC2Type& packet)
{
	Dummy (packet.trapWord);
}

static void Get4 (EmProxySysPktRPC2Type& packet)
{
	Dummy (packet.resultD0);
}

static void Get4 (SysPktRPC2Type& packet)
{
	Dummy (packet.resultD0);
}

static void Dummy (EmProxyFixedGlobalsType&)
{
}

static void Test1 (void)
{
	EmProxySysPktRPC2Type	packet1;
	
	packet1.command = 0x11223344;
	packet1.trapWord = 0x22334455;
	packet1.resultD0 = 0x33445566;

	Get1 (packet1);
}

static void Test2 (void)
{
	SysPktRPC2Type			packet2;

	packet2.command = 0x11223344;
	packet2.trapWord = 0x22334455;
	packet2.resultD0 = 0x33445566;

	Get1 (packet2);
}
#endif

void CheckLayout (void);

void CheckLayout (void)
{
#if 0
	EmProxyFixedGlobalsType	fixed;
	Dummy (fixed);
#endif

	// Verify that the hard-coded offset values in
	// EmStructLayout.h are correct.  Only check on
	// Mac or Windows, since we know those compilers
	// will lay-out the structs correctly.

#if PLATFORM_WINDOWS || PLATFORM_MAC

	FOR_EACH_STRUCT1(CHECK_STRUCT_OFFSETS)
	FOR_EACH_STRUCT2(CHECK_STRUCT_OFFSETS)

	// LowMemHdrType
	// HwrJerryPLDType
	// CardHeaderType
	// SED1375RegsType
	// HwrSymbolASICType
	// UsbHwrType

	// SysAppLaunchCmdOpenDBType

	// ExceptionStackFrame1
	// ExceptionStackFrame2
	// SysEvtMgrGlobalsType
	// SysLibTblEntryType
	// SysLibTblEntryTypeV10
	// Mem1ChunkHeaderType
	// MemChunkHeaderType
	// Mem1HeapHeaderType
	// Mem2HeapHeaderType
	// MemHeapHeaderType
	// Mem1MstrPtrTableType
	// MemMstrPtrTableType
	// HwrM68328Type
	// HwrM68EZ328Type
	// DatabaseHdrType
	// WindowType
	// FormType
	// NetIOParamType
	// NetHostInfoBufType
	// NetServInfoBufType
	// ffs_diskfree_t
	// ffs_ffblk
	// ffs_stat
	// ControlType
	// ListType
	// DataAppInfoType
	// SlkPktHeaderType
	// M68KExcTableType
	// SysAppInfoType
	// M68KExcTableType
#endif
}
