/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef _PLATFORM_FFSLIB_H_
#define _PLATFORM_FFSLIB_H_

#include "Ffs.h"

class Platform_FfsLib
{
   public:

        static Err     LibOpen                 (UInt16 libRef);
        static Err     LibClose                (UInt16 libRef);
        static Err     LibSleep                (UInt16 libRef);
        static Err     LibWake                 (UInt16 libRef);
        static Err     FfsGetLibAPIVersion     (UInt16 libRef, UInt32 *dwVerP);
        static Err     FfsGetdiskfree          (UInt16 libRef, UInt8 drive, ffs_diskfree_t *dtable);
        static Err     FfsFindfirst            (UInt16 libRef, char *path, Int16 attrib, ffs_ffblk *ff_blk);
        static Err     FfsFindnext             (UInt16 libRef, ffs_ffblk *ff_blk);
        static Err     FfsFinddone             (UInt16 libRef, ffs_ffblk *ff_blk);
        static Int16   FfsOpen                 (UInt16 libRef, char *path, Int16 flags, Int16 mode);
        static Err     FfsClose                (UInt16 libRef, Int16 handle);
        static Int16   FfsRead                 (UInt16 libRef, Int16 handle, void *buffer, Int16 num_bytes);
        static Int16   FfsWrite                (UInt16 libRef, Int16 handle, void *buffer, Int16 num_bytes);
        static Err     FfsRemove               (UInt16 libRef, char *path);
        static Err     FfsChdir                (UInt16 libRef, char *path);
        static char   *FfsGetcwd               (UInt16 libRef, char *path, Int16 numchars);
        static Err     FfsMkdir                (UInt16 libRef, char *dirname);
        static Err     FfsRmdir                (UInt16 libRef, char *dirname);
        static Err     FfsFormat               (UInt16 libRef, UInt16 drive);
        static Err     FfsRename               (UInt16 libRef, char *path, char *new_name);
        static Err     FfsGetfileattr          (UInt16 libRef, char *name, UInt16 *attr);
        static Err     FfsFlush                (UInt16 libRef, Int16 handle);
        static Err     FfsFlushDisk            (UInt16 libRef, UInt16 drive);
        static Err     FfsSetfileattr          (UInt16 libRef, char *name, UInt16 attr);
        static Err     FfsStat                 (UInt16 libRef, char *path, ffs_stat *pstat);
        static Err     FfsFstat                (UInt16 libRef, Int16 handle, ffs_stat *pstat);
        static Err     FfsIsDir                (UInt16 libRef, char *path, Boolean *is_dir);
        static Int32   FfsLseek                (UInt16 libRef, Int16 handle, Int32 offset, Int16 origin);
        static Int16   FfsGetErrno             (UInt16 libRef);
        static Int32   FfsTell                 (UInt16 libRef, Int16 handle);
        static void    FfsGetdrive             (UInt16 libRef, UInt16 *drive);
        static void    FfsSetdrive             (UInt16 libRef, UInt16 drive, UInt16 *ndrives);
        static Err     FfsUnlink               (UInt16 libRef, char *path);
        static Err     FfsEof                  (UInt16 libRef, Int16 handle);
        static Int16   FfsCreat                (UInt16 libRef, char *path, Int16 mode);
        static void    FfsInstallErrorHandler  (UInt16 libRef, Int16 (*CritErr)(Int16, Int16, char *));
        static void    FfsUnInstallErrorHandler(UInt16 libRef);
        static void    FfsSetDebuggingOn       (UInt16 libRef, UInt16 s_port, UInt16 level);
        static void    FfsSetDebuggingOff      (UInt16 libRef);
        static Boolean FfsCardIsInserted       (UInt16 libRef, UInt8 drive_num);
        static Err     FfsExerciseFAT          (UInt16 libRef, UInt8 drive_num);
        static Boolean FfsCardIsATA            (UInt16 libRef, UInt8 drive_num);
        static Boolean FfsChangeOccurred       (UInt16 libRef);

};

#endif   // _PLATFORM_FFSLIB_H_
