/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef EmUnixCommon_h
#define EmUnixCommon_h

// Common header file included by all Palm OS Emulator for UNIX files.

// Palm headers

#include "Palm.h"


// UAE headers

#include "UAE.h"


// Std C/C++ Library stuff

// Don't pull these in here.  These would be brought in for *every*
// file, which is too expensive.  We can do this on other platforms,
// as EmulatorCommon.h is the basis for the precompiled header files,
// which load in quickly even with lots of extra stuff in them.

//#include <assert.h>
//#include <ctype.h>				// isalpha, tolower
//#include <stdarg.h>
//#include <stddef.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>

//#include <sys/types.h>
//#include <sys/socket.h>
//#include <sys/ioctl.h>
//#include <netinet/in.h>
//#include <netinet/tcp.h>
//#include <netdb.h>

//#include <algorithm>			// find, sort
//#include <deque>				// deque
//#include <list>					// list
//#include <string>				// list
//#include <utility>				// pair
//#include <vector>
//#include <map>


using namespace std;

typedef	signed char			int8;
typedef signed short		int16;
typedef signed long			int32;
typedef signed long long	int64;

typedef	unsigned char		uint8;
typedef unsigned short		uint16;
typedef unsigned long		uint32;
typedef unsigned long long	uint64;

typedef unsigned long		emuptr;


// Define a boolean type that is most efficient on each platform.
// Yes, they appear to be different...

typedef int		Bool;


#define down fl_down	// "down" defined both in WindowNew.h and Fl/Enumerations.h

#endif	/* EmUnixCommon_h */




