/* -*- mode: C++; tab-width: 4 -*- */
/* ===================================================================== *\
	Copyright (c) 1998-2000 Palm, Inc. or its subsidiaries.
	All rights reserved.

	This file is part of the Palm OS Emulator.

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
\* ===================================================================== */

#ifndef __FLTK_MAINWINDOW_H__
#define __FLTK_MAINWINDOW_H__

#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Button.H>

class Document;
class LCD_window;


class MainWindow : public Fl_Window
{
public:
	// -----------------------------------------------------------------------------
	// constructor / destructor
	// -----------------------------------------------------------------------------

	MainWindow();

	// -----------------------------------------------------------------------------
	// public methods
	// -----------------------------------------------------------------------------

	void popupMenu() { (void) _menuButton->popup(); }

	Document* getDocument() { return _doc; }

	static MainWindow* getMainWindow() { return _sMainWindow; };

private:
public:

	// -----------------------------------------------------------------------------
	// private methods
	// -----------------------------------------------------------------------------

	void doLoadApplication();
	void doExportDatabase();
	void doEmulatorStart();
	Bool doEmulatorStop();
	void doQuit();
	void doSaveMemory();
	void doSaveMemoryAs();
	void doSaveScreen();
	void doOpenMemory();

	void doEditLoggingPreferences();
	void doEditDebugPreferences();
	void doEditSkins();
	void doEditPreferences();

	friend void menuCallback( Fl_Menu_ *w, void *data );
	friend void docChangedCallback( int property, void *param );

	// -----------------------------------------------------------------------------
	// private data members
	// -----------------------------------------------------------------------------

	Fl_Menu_Button *_menuButton;
	LCD_window *_lcd;

	Document *_doc;

	static MainWindow* _sMainWindow;
};

#endif /* __FLTK_MAINWINDOW_H__ */
